// Test1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Test1.h"
#include "Test1Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CTest1Dlg dialog

CTest1Dlg::CTest1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest1Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTest1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTest1Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTest1Dlg, CDialog)
	//{{AFX_MSG_MAP(CTest1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest1Dlg message handlers

BOOL CTest1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTest1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTest1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}




//!! DX Atlas 
struct StartUpCom {
    StartUpCom() { CoInitialize(NULL); }
    ~StartUpCom() { CoUninitialize(); }
} _global_com_inst;




//!! connect to DX Atlas
void CTest1Dlg::OnButton1() 
{
	
  try {
    // Connect to DX Atlas if it is running
    HRESULT hr = pAtlas.GetActiveObject(L"DxAtlas.Atlas");
    if (FAILED(hr)) _com_issue_error(hr);
  }
  catch (_com_error& e){
    // Start a new instance of DX Atlas
    HRESULT hr = pAtlas.CreateInstance(L"DxAtlas.Atlas", NULL, CLSCTX_LOCAL_SERVER);
    if (FAILED(hr)) _com_issue_error(hr);
  }
	

  //Set window dimensions
  pAtlas->Top = 50;
  pAtlas->Left = 50;
  pAtlas->Width = 500;
  pAtlas->Height = 400;  
}


//!! disconnect from DX Atlas
void CTest1Dlg::OnButton2() 
{
  pAtlas = NULL;	
}


//!! Show/hide the Atlas window
void CTest1Dlg::OnButton3() 
{
if (pAtlas == NULL) MessageBox("Not connected");
else {pAtlas->Visible = !pAtlas->Visible;};
}


//!! Set Home location
void CTest1Dlg::OnButton5() 
{
  if (pAtlas == NULL) MessageBox("Not connected");
  else {
	pAtlas->Map->HomeLatitude = 43;	
    pAtlas->Map->HomeLongitude = -79.5;	
  }
}

//!! Set DX location
void CTest1Dlg::OnButton6() 
{
  if (pAtlas == NULL) MessageBox("Not connected");
  else {
	pAtlas->Map->DxLatitude = -10;	
    pAtlas->Map->DxLongitude = 149;	
	pAtlas->Map->DxVisible = TRUE;
  }
}


//!! Hide DX marker
void CTest1Dlg::OnButton7() 
{
  if (pAtlas == NULL) MessageBox("Not connected");
  else {
	pAtlas->Map->DxVisible = FALSE;
  }
}

//!! Zoom to DX
void CTest1Dlg::OnButton8() 
{
  if (pAtlas == NULL) MessageBox("Not connected");
  else {
    OnButton6();
	pAtlas->Map->CenterLatitude = pAtlas->Map->DxLatitude;
	pAtlas->Map->CenterLongitude = pAtlas->Map->DxLongitude;
    pAtlas->Map->Zoom = 10;
  }
}




void CTest1Dlg::OnButton4() 
{
  if (pAtlas == NULL) MessageBox("Not connected");
  else {

	long ix;

    _variant_t vtLat, vtLon, vtText;
	_variant_t vtLabel, vtLabels;

    vtLat.ChangeType(VT_R4);
    vtLon.ChangeType(VT_R4);

    vtLabel.vt = VT_ARRAY | VT_VARIANT;
    vtLabels.vt = VT_ARRAY | VT_VARIANT;

	//create array of labels
    SAFEARRAY * pLabels = MakeArray(100);

	//add 100 random labels
	srand( (unsigned)time( NULL ) ); 
	for (int i=0; i<100; i++) {
	  //create label entry (array of 3 elements: Lon, Lat, Text)
	  SAFEARRAY * pLabel = MakeArray(3);
	  //calculate attributes
      vtLon = Random(180);
      vtLat = Random(90);
	  vtText.SetString("Label");
	  //set attributes
	  ix = 0; SafeArrayPutElement(pLabel, &ix, &vtLon);
	  ix = 1; SafeArrayPutElement(pLabel, &ix, &vtLat);
	  ix = 2; SafeArrayPutElement(pLabel, &ix, &vtText);
	  //add label to the array
	  vtLabel.parray = pLabel;
	  ix = i; SafeArrayPutElement(pLabels, &ix, &vtLabel);
	  }  
   

    //do not repaint map while we are updating data
    pAtlas->Map->BeginUpdate();
    //optionally set map projection
    pAtlas->Map->Projection = DxAtlas::PRJ_RECTANGULAR;
    //delete all existing layers
    pAtlas->Map->CustomLayers->Clear();
    //add new layer
    DxAtlas::ICustomLayerPtr pLayer = pAtlas->Map->CustomLayers->Add(DxAtlas::LK_LABELS);
    //set layer type: labels
    pLayer->LabelsTransparent = true;
    //optionally set other attributes
    pLayer->BrushColor = DxAtlas::clAqua;
    //font attributes
    IFontPtr pFont = pLayer->GetFont();
    pFont->put_Name(_com_util::ConvertStringToBSTR("Arial"));
    //pFont->put_Name(_com_util::ConvertStringToBSTR("Courier New"));
    pFont->put_Italic(true);
    //font color
    pLayer->PenColor = DxAtlas::clNavy;
    //put data into the layer
    vtLabels.parray = pLabels;
    pLayer->SetData(vtLabels);
    //now allow repainting
    pAtlas->Map->EndUpdate();
    }
}




void CTest1Dlg::OnButton10() 
{
  if (pAtlas == NULL) MessageBox("Not connected");
  else {

	//find Glyphs.bmp
    CString Dir = __argv[0];
	Dir.Delete(Dir.ReverseFind('\\'), Dir.GetLength() - Dir.ReverseFind('\\'));
    _bstr_t Path = Dir + "\\Glyphs.bmp";

	CFileFind finder;
	if (!finder.FindFile(Path)) {
      Dir.Delete(Dir.ReverseFind('\\'), Dir.GetLength() - Dir.ReverseFind('\\'));
      Path = Dir + "\\Glyphs.bmp";
	};

	if (!finder.FindFile(Path)) {
	  MessageBox("Cannot find Glyphs.bmp");
	  return;
	}

	
	
	
	long ix;

    _variant_t vtLat, vtLon, vtGlyphIndex;
	_variant_t vtGlyph, vtGlyphs;

    vtLat.ChangeType(VT_R4);
    vtLon.ChangeType(VT_R4);
    vtGlyphIndex.ChangeType(VT_R4);

    vtGlyph.vt = VT_ARRAY | VT_VARIANT;
    vtGlyphs.vt = VT_ARRAY | VT_VARIANT;

	//create array of glyphs
    SAFEARRAY * pGlyphs = MakeArray(100);

	//add 100 random glyphs
	srand( (unsigned)time( NULL ) ); 
	for (int i=0; i<100; i++) {
	  //create glyph entry (array of 3 elements: Lon, Lat, GlyphIndex)
	  SAFEARRAY * pGlyph = MakeArray(3);
	  //assign random attributes
      vtLon = Random(180);
      vtLat = Random(90);
	  vtGlyphIndex = Random(10);
	  //set attributes
	  ix = 0; SafeArrayPutElement(pGlyph, &ix, &vtLon);
	  ix = 1; SafeArrayPutElement(pGlyph, &ix, &vtLat);
	  ix = 2; SafeArrayPutElement(pGlyph, &ix, &vtGlyphIndex);
	  //add glyph to the array
	  vtGlyph.parray = pGlyph;
	  ix = i; SafeArrayPutElement(pGlyphs, &ix, &vtGlyph);
	}  
   

    //do not repaint map while we are updating data
    pAtlas->Map->BeginUpdate();
    //optionally set map projection
    pAtlas->Map->Projection = DxAtlas::PRJ_RECTANGULAR;

    //delete all existing layers, add a new layer
	//in a real world application you will create layers once on program start
	//and then replace layer data when necessary: pLayer->SetData()
    pAtlas->Map->CustomLayers->Clear();
    DxAtlas::ICustomLayerPtr pLayer = pAtlas->Map->CustomLayers->Add(DxAtlas::LK_GLYPHS);

	//load glyphs
	//(1,15) is the hot spot of the glyph, 
	//i.e., the pixel that will be placed at the specified lat/lon
    pLayer->LoadGlyphsFromFile(Path, 1, 15);

    //put data into the layer
    vtGlyphs.parray = pGlyphs;
    pLayer->SetData(vtGlyphs);

    //now allow repainting
    pAtlas->Map->EndUpdate();
  };
}





SAFEARRAY* CTest1Dlg::MakeArray(int cElements)
{
   SAFEARRAYBOUND rgsabound[1];

   rgsabound[0].lLbound = 0;
   rgsabound[0].cElements = cElements;

   return SafeArrayCreate(VT_VARIANT, 1, rgsabound);
}



float CTest1Dlg::Random(float Range)
{
  return float(rand()*2.0/RAND_MAX*Range - Range); 
}




